// ABSpread.idl : IDL source for ABSpread.exe
//
// This file will be processed by the MIDL tool to
// produce the type library (ABSpread.tlb) and marshalling code.
import "oaidl.idl";
import "ocidl.idl";
//forward declarations		
interface IApplication;
interface IWorkbook;
interface Workbooks;
interface Worksheets;
interface Worksheet;
interface Range;
interface Font;
interface NumberFormat;
interface Border;
interface Borders;
interface Chart;
interface Charts;
interface ChartFillStyle;
interface ChartTitle;
interface ChartTitles;
interface ChartLegend;
interface ChartLegends;

<begin>


enum ABWindowState //////
{
	abMaximized = -4137L,	
	abMinimized = -4140L,
	abNormal = -4143L
} ;

enum ABDeleteShiftDirection //////
{
	abShiftToLeft = -4159, 
	abShiftUp = -4162
} ;

enum  ABInsertShiftDirection //////
{
	abShiftDown = -4121,	
	abShiftToRight = -4161
};

enum ABNumberFormatType //////
{
	abNumberFormatGeneral, _
	abNumberFormatNumber,_
	abNumberFormatCurrency,_
	abNumberFormatPercent,_
	abNumberFormatFraction,_
	abNumberFormatScientific,_
	abNumberFormatTime,_
	abNumberFormatDate,_
		abNumberFormatBool _
} ;	

enum ABLeadTrailType //////
{
	abLeadTrailNone, _
	abLeadTrailLeading,_
	abLeadTrailTrailing _
} ;

enum ABFractionType //////
{
	abFractionAuto, _
	abFraction100th, _
	abFraction10th, _
	abFraction16th, _
	abFraction8th, _
	abFraction4th _
} ;

enum  ABDateMonthType //////
{
	abDateMonthShortName, _
	abDateMonthLongName, _
	abDateMonthDigits _
};

enum  ABDateYearType //////
{
	abDateYearLong, _
	abDateYearNone, _
	abDateYearShort _
};

enum  ABDayMonthOrderType //////
{
	abMonthDayOrder, _
	abDayMonthOrder _
};

enum  ABHorizontalAlignment //////
{
	abHAlignLeft, _
	abHAlignCenter, _
	abHAlignRight _
};

enum  ABVerticalAlignment //////
{
	abVAlignTop, _
	abVAlignCenter, _
	abVAlignBottom _
};


enum   ABBorderIndex //////
{
	abBorderBottom = 9,
	abBorderLeft = 7,
	abBorderRight = 10,
	abBorderTop = 8
};

enum  ABLineStyle //////
{
	abLineStyleNone, _
	abLineStyleContinuousThin, _
	abLineStyleContinuousMedium, _
	abLineStyleContinuousThick, _
	abLineStyleDot, _
	abLineStyleDashThin, _
	abLineStyleDashThick, _
	abLineStyleDashDot _
};

enum ABChartStyle //////
	{
		abChartStyleLine, _
		abChartStyleHBar, _
		abChartStyleVBar, _
		abChartStylePie , _
		abChartStyleHistogram, _
		abChartStyleArea, _
		abChartStyleStock, _
		abChartStyleOscilloscope, _
		abChartStyleIsoBar, _
		abChartStyleIsoArea, _
		abChartStyleStackVBar, _
		abChartStyleStackHBar, _
		abChartStyleIsoPie, _
		abChartStyleStrata, _
		abChartStyleExVBar, _
		abChartStyleExHBar, _
		abChartStyleRibbon, _
		abChartStyleWeb, _
		abChartStyleXYScatterA, _
		abChartStyleXYScatterI, _
		abChartStyleXYScatterG, _
		abChartStyleTimeSpan, _
		abChartStyleAreaWeb, _
		abChartStyleAreaStock, _
		abChartStyleFreeStyle, _
		abChartStylePolar, _
		abChartStyleAreaPolar, _
		abChartStyleCandle, _
		abChartStyleHiLoOpenClose, _
		abChartStyleGantt, _
		abChartStyleLineOnly, _
		abChartStyleXYScatterAEx, _
		abChartStyleXYScatterIEx, _
		abChartStyleXYScatterGEx, _
		abChartStyleStep, _
		abChartStyleStepLo, _
		abChartStyleStrataVBar, _
		abChartStyleStrataHBar, _
		abChartStyleStrataVBarG, _
		abChartStyleStrataHBarG, _
		abChartStyleBubbleR, _
		abChartStyleBubbleA, _
		abChartStyleVectorE, _
		abChartStyleVectorC, _
		abChartStyleVectorG _ 
	} ;

	enum ABChartBorder //////
	{
		abChartBoderNoBorder, _
		abChartBorderThinRaised, _
		abChartBorderThinSunken, _
		abChartBorderThin3D, _
		abChartBorderThickRaised, _
		abChartBorderThickSunken, _
		abChartBorderThick3D, _
		abChartBorderLine _
	} ;

	enum ABChartShadow //////
	{
		abChartShadowNoShadow, _
		abChartShadowThin, _
		abChartShadowMedium, _
		abChartShadowThick _
	} ;

	enum ABChartAxisType //////
	{
		abChartAxisAutomatic, _
		abChartAxisClassic, _
		abChartAxisOscilloscope, _
		abChartAxisPlatformSE, _
		abChartAxisPlatformSW, _
		abChartAxisStageSE, _
		abChartAxisStageSW, _
		abChartAxisHFrame, _
		abChartAxisPie, _
		abChartAxisYX, _
		abChartAxisIsoClassic, _
		abChartAxisClassicRight, _
		abChartAxisIsoClassicR, _
		abChartAxisWeb, _
		abChartAxisXYScatter, _
		abChartAxisIsoClassicYX, _
		abChartAxisPolar, _
		abChartAxisDate, _
		abChartAxisDateR, _
		abChartAxisIsoDate, _
		abChartAxisIsoDateR, _
		abChartAxisIsoDateYX, _
		abChartAxisDateYX, _
		abChartAxisGanttValue, _
		abChartAxisGanttDate, _
		abChartAxisScatterDateX, _
		abChartAxisScatterDateY _
	} ;

	enum ABFillStyleType //////
	{
		abFillStyleNone, _
		abFillStyleSolid, _
		abFillStyleVertical, _
		abFillStyleHorizontal, _
		abFillStyleAngle, _
		abFillStyleImage _
	} ;

	enum ABChartTitleIndex //////
	{
		abChartTitleTop, _
		abChartTitleLeft, _
		abChartTitleBottom, _
		abChartTitleRight _
	} ;		

	enum ABChartLegendIndex //////
	{
		abChartLegendTop, _
		abChartLegendLeft, _
		abChartLegendBottom, _
		abChartLegendRight _
	} ;		

class IApplication //////
{
[properties:
	[propget, id(1), helpstring("property Visible")] 
	BOOL  Visible();
	[propput, id(1), helpstring("property Visible")] 
	HRESULT Visible(  BOOL newVal);
	[propget, id(2), helpstring("property UserControl")] 
	BOOL UserControl( );
	[propput, id(2), helpstring("property UserControl")] 
	HRESULT UserControl(  BOOL newVal);
	[propget, id(3), helpstring("property WindowState")] 
	ABWindowState WindowState( );
	[propput, id(3), helpstring("property WindowState")] 
	HRESULT WindowState(  ABWindowState newVal);
	[propget, id(4), helpstring("property ActiveWorkbook")] 
	IWorkbook ActiveWorkbook( );
	[propget, id(5), helpstring("property Workbooks")] 
	Workbooks Workbooks(  );
	[propget, id(6), helpstring("property ActiveCell")] 
	Range ActiveCell(  );
	[propget, id(7), helpstring("property Selection")] 
	Range Selection(  );
	[propget, id(8), helpstring("property Range")] 
	Range Range(VARIANT range);
	[propget, id(9), helpstring("property Caption")] 
	BSTR  Caption( );
	[propget, id(10), helpstring("property ActiveSheet")] 
	Worksheet ActiveSheet(  );
	[propget, id(11), helpstring("property Cells")] 
	Range Cells(  );
]
[methods:
	[id(12), helpstring("method Quit")] 
	HRESULT Quit();
	[id(13), helpstring("method Calculate")] 
	HRESULT Calculate();
]
};


class IWorkbook //////
{
[methods:
	[id(1), helpstring("method Close")] 
	HRESULT Close( VARIANT SaveChanges,  VARIANT FileName);
	[id(3), helpstring("method Save")] 
	HRESULT Save();
	[id(7), helpstring("method Calculate")] 
	HRESULT Calculate();
	[id(8), helpstring("method SaveAs")] 
	HRESULT SaveAs(BSTR FileName);
	[id(9), helpstring("method Activate")] 
	HRESULT Activate();
	[id(13), helpstring("method Protect")] 
	HRESULT Protect(BSTR Password);
	[id(14), helpstring("method Unprotect")] 
	HRESULT Unprotect(BSTR Password);
]
[properties:
	[propget, id(2), helpstring("property Application")] 
	IApplication Application(  );
	[propget, id(4), helpstring("property Saved")] 
	BOOL  Saved( );
	[propput, id(4), helpstring("property Saved")] 
	HRESULT Saved(  BOOL newVal);
	[propget, id(5), helpstring("property Worksheets")] 
	Worksheets Worksheets(  );
	[propget, id(6), helpstring("property ActiveSheet")] 
	Worksheet ActiveSheet(  );
	[propget, id(10), helpstring("property Name")] 
	BSTR  Name( );
	[propget, id(11), helpstring("property Path")] 
	BSTR  Path( );
	[propget, id(12), helpstring("property Protected")] 
	BOOL  Protected( );
	[propget, id(15), helpstring("property Forms")] 
	LPDISPATCH  Forms( );
]
};


class Workbooks //////
{
[properties:
	[propget, id(1), helpstring("property Application")] 
	IApplication Application( );
	[propget, id(2), helpstring("property Count")] 
	long  Count( );
	[propget, id(DISPID_NEWENUM), helpstring("property _NewEnum"), restricted] 
	IUnknown _NewEnum( );
	[propget, id(DISPID_VALUE), helpstring("property Item")] 
	IWorkbook Item( VARIANT Index );
]
[methods:
	[id(3), helpstring("method Add")] 
	IWorkbook Add();
	[id(4), helpstring("method Close")] 
	HRESULT Close();
	[id(5), helpstring("method Open")] 
	IWorkbook Open( BSTR FileName );
]
};


class Worksheets //////
{
[properties:
	[propget, id(1), helpstring("property Application")] 
	IApplication Application( );
	[propget, id(2), helpstring("property Count")] 
	long  Count();
	[propget, id(DISPID_NEWENUM), helpstring("property _NewEnum"), restricted] 
	IUnknown _NewEnum();
	[propget, id(DISPID_VALUE), helpstring("property Item")] 
	Worksheet Item( VARIANT Index);
]
};


class Worksheet //////
{
[properties:
	[propget, id(1), helpstring("property Name")] 
	BSTR  Name();
	[propput, id(1), helpstring("property Name")] 
	HRESULT Name(  BSTR newVal);
	[propget, id(2), helpstring("property Cells")] 
	Range Cells();
	[propget, id(3), helpstring("property Range")] 
	Range Range( VARIANT range);
	[propget, id(4), helpstring("property Application")] 
	IApplication Application();
	[propget, id(5), helpstring("property Index")] 
	long  Index();
	[propget, id(7), helpstring("property AutoCalculate")] 
	BOOL  AutoCalculate();
	[propput, id(7), helpstring("property AutoCalculate")] 
	HRESULT AutoCalculate(  BOOL newVal);
	[propget, id(12), helpstring("property ActiveCell")] 
	Range ActiveCell();
	[propget, id(13), helpstring("property LastCell")] 
	Range LastCell();

]
[methods:
	[id(6), helpstring("method Calculate")] 
	HRESULT Calculate();
	[id(8), helpstring("method Delete")] 
	HRESULT Delete();
	[id(9), helpstring("method Activate")] 
	HRESULT Activate();
	[id(11), helpstring("method PrintOut")] 
	HRESULT PrintOut(VARIANT StartPage, VARIANT EndPage, VARIANT Copies, VARIANT PrintToFile, VARIANT Collate);
]
};


class Range //////
{
[properties:
	[propget, id(1), helpstring("property Formula")] 
	VARIANT  Formula();
	[propput, id(1), helpstring("property Formula")] 
	HRESULT Formula(  VARIANT newVal);
	[propget, id(2), helpstring("property Font")] 
	Font Font();
	[propput, id(2), helpstring("property Font")] 
	HRESULT Font(  Font* newVal);
	[propget, id(3), helpstring("property Application")] 
	IApplication Application();
	[propget, id(4), helpstring("property Cells")] 
	Range Cells();
	[propget, id(5), helpstring("property Range")] 
	Range Range( VARIANT range);
	[propget, id(6), helpstring("property Value")] 
	VARIANT  Value();
	[propput, id(6), helpstring("property Value")] 
	HRESULT Value(  VARIANT newVal);
	[propget, id(7), helpstring("property Worksheet")] 
	Worksheet Worksheet();
	[propget, id(8), helpstring("property NumberFormat")] 
	NumberFormat NumberFormat();
	[propput, id(8), helpstring("property NumberFormat")] 
	HRESULT NumberFormat(  NumberFormat* newVal);
	[propget, id(9), helpstring("property HorizontalAlignment")] 
	ABHorizontalAlignment  HorizontalAlignment();
	[propput, id(9), helpstring("property HorizontalAlignment")] 
	HRESULT HorizontalAlignment(  ABHorizontalAlignment newVal);
	[propget, id(10), helpstring("property VerticalAlignment")] 
	ABVerticalAlignment  VerticalAlignment();
	[propput, id(10), helpstring("property VerticalAlignment")] 
	HRESULT VerticalAlignment(  ABVerticalAlignment newVal);
	[propget, id(11), helpstring("property WrapText")] 
	BOOL  WrapText();
	[propput, id(11), helpstring("property WrapText")] 
	HRESULT WrapText(  BOOL newVal);
	[propget, id(12), helpstring("property FormulaHidden")] 
	BOOL  FormulaHidden();
	[propput, id(12), helpstring("property FormulaHidden")] 
	HRESULT FormulaHidden(  BOOL newVal);
	[propget, id(13), helpstring("property Locked")] 
	BOOL  Locked();
	[propput, id(13), helpstring("property Locked")] 
	HRESULT Locked(  BOOL newVal);
	[propget, id(14), helpstring("property ErrorHidden")] 
	BOOL  ErrorHidden();
	[propput, id(14), helpstring("property ErrorHidden")] 
	HRESULT ErrorHidden(  BOOL newVal);
	[propget, id(15), helpstring("property ZeroHidden")] 
	BOOL  ZeroHidden();
	[propput, id(15), helpstring("property ZeroHidden")] 
	HRESULT ZeroHidden(  BOOL newVal);
	[propget, id(32), helpstring("property Address")] 
	BSTR Address();
	[propget, id(33), helpstring("property Row")] 
	long Row();
	[propget, id(34), helpstring("property Column")] 
	long Column();

]
[methods:
	[id(16), helpstring("method Activate")] 
	HRESULT Activate();
	[id(17), helpstring("method Select")] 
	HRESULT Select();
	[id(18), helpstring("method Copy")] 
	HRESULT Copy( VARIANT Destination);
	[id(19), helpstring("method Calculate")] 
	HRESULT Calculate();
	[id(20), helpstring("method Paste")] 
	HRESULT Paste();
	[id(21), helpstring("method Cut")] 
	HRESULT Cut( VARIANT Destination);
	[id(22), helpstring("method Clear")] 
	HRESULT Clear();
	[id(23), helpstring("method ClearContents")] 
	HRESULT ClearContents();
	[id(24), helpstring("method ClearFormats")] 
	HRESULT ClearFormats();
	[id(25), helpstring("method Delete")] 
	HRESULT Delete( VARIANT Shift);
	[id(27), helpstring("method Insert")] 
	HRESULT Insert( VARIANT Shift);
	[id(29), helpstring("method ClearOutline")] 
	HRESULT ClearOutline();
]
[properties:
	[propget, id(26), helpstring("property Color")] 
	ABColor  Color();
	[propput, id(26), helpstring("property Color")] 
	HRESULT Color(  ABColor newVal);
	[propget, id(28), helpstring("property Borders")] 
	Borders Borders();
	[propget, id(DISPID_VALUE), helpstring("property Item")] 
	Range Item(VARIANT RowIndex,  VARIANT ColIndex);
]
};


class Font //////
{
[properties:
	[propget, id(1), helpstring("property Bold")] 
	BOOL  Bold();
	[propput, id(1), helpstring("property Bold")] 
	HRESULT Bold(  BOOL newVal);
	[propget, id(2), helpstring("property Italic")] 
	BOOL  Italic();
	[propput, id(2), helpstring("property Italic")] 
	HRESULT Italic(  BOOL newVal);
	[propget, id(3), helpstring("property Underline")] 
	BOOL  Underline();
	[propput, id(3), helpstring("property Underline")] 
	HRESULT Underline(  BOOL newVal);
	[propget, id(4), helpstring("property Strikeout")] 
	BOOL  Strikeout();
	[propput, id(4), helpstring("property Strikeout")] 
	HRESULT Strikeout(  BOOL newVal);
	[propget, id(5), helpstring("property Size")] 
	long  Size();
	[propput, id(5), helpstring("property Size")] 
	HRESULT Size(  long newVal);
	[propget, id(6), helpstring("property Name")] 
	BSTR  Name();
	[propput, id(6), helpstring("property Name")] 
	HRESULT Name(  BSTR newVal);
	[propget, id(7), helpstring("property Color")] 
	ABColor  Color();
	[propput, id(7), helpstring("property Color")] 
	HRESULT Color(  ABColor newVal);
]
};


class NumberFormat //////
{
[properties:
	[propget, id(1), helpstring("property Type")] 
	ABNumberFormatType  Type();
	[propput, id(1), helpstring("property Type")] 
	HRESULT Type(  ABNumberFormatType newVal);
	[propget, id(2), helpstring("property Precision")] 
	short  Precision();
	[propput, id(2), helpstring("property Precision")] 
	HRESULT Precision(  short newVal);
	[propget, id(3), helpstring("property Commas")] 
	BOOL  Commas();
	[propput, id(3), helpstring("property Commas")] 
	HRESULT Commas(  BOOL newVal);
	[propget, id(4), helpstring("property Brackets")] 
	BOOL  Brackets();
	[propget, id(7), helpstring("property Fraction")] 
	ABFractionType  Fraction();
	[propput, id(7), helpstring("property Fraction")] 
	HRESULT Fraction(  ABFractionType newVal);
	[propget, id(8), helpstring("property Seconds")] 
	BOOL  Seconds();
	[propput, id(8), helpstring("property Seconds")] 
	HRESULT Seconds(  BOOL newVal);
	[propget, id(9), helpstring("property TimeAM")] 
	BOOL  TimeAM();
	[propput, id(9), helpstring("property TimeAM")] 
	HRESULT TimeAM(  BOOL newVal);
	[propget, id(10), helpstring("property LeadTrailString")] 
	BSTR  LeadTrailString();
	[propput, id(10), helpstring("property LeadTrailString")] 
	HRESULT LeadTrailString(  BSTR newVal);
	[propput, id(4), helpstring("property Brackets")] 
	HRESULT Brackets(  BOOL newVal);
	[propget, id(5), helpstring("property Red")] 
	BOOL  Red();
	[propput, id(5), helpstring("property Red")] 
	HRESULT Red(  BOOL newVal);
	[propget, id(6), helpstring("property LeadTrail")] 
	ABLeadTrailType  LeadTrail();
	[propput, id(6), helpstring("property LeadTrail")] 
	HRESULT LeadTrail(  ABLeadTrailType newVal);
	[propget, id(11), helpstring("property DateSeparator")] 
	BSTR  DateSeparator();
	[propput, id(11), helpstring("property DateSeparator")] 
	HRESULT DateSeparator(  BSTR newVal);
	[propget, id(12), helpstring("property Time")] 
	BOOL  Time();
	[propput, id(12), helpstring("property Time")] 
	HRESULT Time(  BOOL newVal);
	[propget, id(13), helpstring("property DateMonth")] 
	ABDateMonthType  DateMonth();
	[propput, id(13), helpstring("property DateMonth")] 
	HRESULT DateMonth(  ABDateMonthType newVal);
	[propget, id(14), helpstring("property DateYear")] 
	ABDateYearType  DateYear();
	[propput, id(14), helpstring("property DateYear")] 
	HRESULT DateYear(  ABDateYearType newVal);
	[propget, id(15), helpstring("property DayMonthOrder")] 
	ABDayMonthOrderType  DayMonthOrder();
	[propput, id(15), helpstring("property DayMonthOrder")] 
	HRESULT DayMonthOrder(  ABDayMonthOrderType newVal);
]
};


class Border //////
{
[properties:
	[propget, id(1), helpstring("property LineStyle")] 
	ABLineStyle  LineStyle();
	[propput, id(1), helpstring("property LineStyle")] 
	HRESULT LineStyle(  ABLineStyle newVal);
	[propget, id(2), helpstring("property Color")] 
	ABColor  Color();
	[propput, id(2), helpstring("property Color")] 
	HRESULT Color(  ABColor newVal);
]
};


class Borders //////
{
[properties:
	[propget, id(1), helpstring("property LineStyle")] 
	ABLineStyle  LineStyle();
	[propput, id(1), helpstring("property LineStyle")] 
	HRESULT LineStyle(  ABLineStyle newVal);
	[propget, id(2), helpstring("property Color")] 
	ABColor  Color();
	[propput, id(2), helpstring("property Color")] 
	HRESULT Color(  ABColor newVal);
	[propget, id(DISPID_VALUE), helpstring("property Item")] 
	Border Item(  ABBorderIndex BorderIndex);
	[propget, id(DISPID_NEWENUM), helpstring("property _NewEnum"), restricted] 
	IUnknown _NewEnum();
]
};

class Chart //////
{
[properties:

	[propget, id(1), helpstring("property DataRange")] 
	BSTR DataRange();
	[propput, id(1), helpstring("property DataRange")] 
	HRESULT DataRange(BSTR newVal);
	[propget, id(2), helpstring("property SeriesVertically")] 
	BOOL SeriesVertically();
	[propput, id(2), helpstring("property SeriesVertically")] 
	HRESULT SeriesVertically(BOOL newVal);
	[propget, id(3), helpstring("property FirstColumnData")] 
	BOOL FirstColumnData();
	[propput, id(3), helpstring("property FirstColumnData")] 
	HRESULT FirstColumnData(BOOL newVal);
	[propget, id(4), helpstring("property FirstRowData")] 
	BOOL FirstRowData();
	[propput, id(4), helpstring("property FirstRowData")] 
	HRESULT FirstRowData(BOOL newVal);
	[propget, id(5), helpstring("property ChartStyle")] 
	ABChartStyle ChartStyle();
	[propput, id(5), helpstring("property ChartStyle")] 
	HRESULT ChartStyle(ABChartStyle newVal);
	[propget, id(6), helpstring("property Border")] 
	ABChartBorder Border();
	[propput, id(6), helpstring("property Border")] 
	HRESULT Border(ABChartBorder newVal);
	[propget, id(7), helpstring("property Shadow")] 
	ABChartShadow Shadow();
	[propput, id(7), helpstring("property Shadow")] 
	HRESULT Shadow(ABChartShadow newVal);
	[propget, id(8), helpstring("property AxisType")] 
	ABChartAxisType AxisType();
	[propput, id(8), helpstring("property AxisType")] 
	HRESULT AxisType(ABChartAxisType newVal);
	[propget, id(9), helpstring("property Font")] 
	Font Font();
	[propput, id(9), helpstring("property Font")] 
	HRESULT Font(Font* newVal);
	[propget, id(10), helpstring("property FillStyle")] 
	ChartFillStyle *FillStyle();
	[propput, id(10), helpstring("property FillStyle")] 
	HRESULT FillStyle(ChartFillStyle newVal);
	[propget, id(11), helpstring("property Titles")] 
	ChartTitles Titles();
	[propget, id(12), helpstring("property Legends")] 
	ChartLegends Legends();
]
[methods:
	[id(13), helpstring("method Update")] 
	HRESULT Update();
]
};

class ChartFillStyle //////
{
[properties:
	[propget, id(1), helpstring("property Type")] 
	ABFillStyleType Type();
	[propput, id(1), helpstring("property Type")] 
	HRESULT Type(ABFillStyleType newVal);
	[propget, id(2), helpstring("property Angle")] 
	long Angle();
	[propput, id(2), helpstring("property Angle")] 
	HRESULT Angle(long newVal);
	[propget, id(3), helpstring("property StartColor")] 
	ABColor StartColor();
	[propput, id(3), helpstring("property StartColor")] 
	HRESULT StartColor(ABColor newVal);
	[propget, id(4), helpstring("property EndColor")] 
	ABColor EndColor();
	[propput, id(4), helpstring("property EndColor")] 
	HRESULT EndColor(ABColor newVal);
	[propget, id(5), helpstring("property ImageFileName")] 
	BSTR ImageFileName();
	[propput, id(5), helpstring("property ImageFileName")] 
	HRESULT ImageFileName(BSTR newVal);
	[propget, id(6), helpstring("property StretchImage")] 
	BOOL StretchImage();
	[propput, id(6), helpstring("property StretchImage")] 
	HRESULT StretchImage(BOOL newVal);
]
};


class ChartTitle //////
{
[properties:
	[propget, id(1), helpstring("property Enabled")] 
	BOOL Enabled();
	[propput, id(1), helpstring("property Enabled")] 
	HRESULT Enabled(BOOL newVal);
	[propget, id(2), helpstring("property Text")] 
	BSTR Text();
	[propput, id(2), helpstring("property Text")] 
	HRESULT Text(BSTR newVal);
	[propget, id(3), helpstring("property Border")] 
	ABChartBorder Border();
	[propput, id(3), helpstring("property Border")] 
	HRESULT Border(ABChartBorder newVal);
	[propget, id(4), helpstring("property Shadow")] 
	ABChartShadow Shadow();
	[propput, id(4), helpstring("property Shadow")] 
	HRESULT Shadow(ABChartShadow newVal);
	[propget, id(5), helpstring("property FillStyle")] 
	ChartFillStyle FillStyle();
	[propput, id(5), helpstring("property FillStyle")] 
	HRESULT FillStyle(ChartFillStyle* newVal);
	[propget, id(6), helpstring("property Font")] 
	Font Font();
	[propput, id(6), helpstring("property Font")] 
	HRESULT Font(Font* newVal);
]
};

class ChartLegend //////
{
[properties:
	[propget, id(1), helpstring("property Border")] 
	ABChartBorder Border();
	[propput, id(1), helpstring("property Border")] 
	HRESULT Border(ABChartBorder newVal);
	[propget, id(2), helpstring("property Shadow")] 
	ABChartShadow Shadow();
	[propput, id(2), helpstring("property Shadow")] 
	HRESULT Shadow(ABChartShadow newVal);
	[propget, id(3), helpstring("property FillStyle")] 
	ChartFillStyle FillStyle();
	[propput, id(3), helpstring("property FillStyle")] 
	HRESULT FillStyle(ChartFillStyle* newVal);
	[propget, id(4), helpstring("property Font")] 
	Font Font();
	[propput, id(4), helpstring("property Font")] 
	HRESULT Font(Font* newVal);
	[propget, id(5), helpstring("property Enabled")] 
	BOOL Enabled();
	[propput, id(5), helpstring("property Enabled")] 
	HRESULT Enabled(BOOL newVal);
]
};


class ChartTitles //////
{
[properties:
	[propget, id(DISPID_VALUE), helpstring("property Item")] 
	ChartTitle Item(ABChartTitleIndex TitleIndex);
	[propget, id(DISPID_NEWENUM), helpstring("property _NewEnum")] 
	IUnknown _NewEnum();
]
};

class ChartLegends  //////
{
[properties:
	[propget, id(DISPID_VALUE), helpstring("property Item")] 
	ChartLegend Item(ABChartLegendIndex LegendIndex);
	[propget, id(DISPID_NEWENUM), helpstring("property _NewEnum")] 
	IUnknown _NewEnum();
]
};

